﻿using Microsoft.Extensions.DependencyInjection;

namespace Platform.Modules.Abstract
{
    public interface IModule
    {
        /// <summary>
        /// Gets or sets the plugins name
        /// </summary>
        string Name { get; }

        /// <summary>
        /// Gets the folder of this module
        /// </summary>
        string Folder { get; }

        /// <summary>
        /// Initialize plugin
        /// </summary>
        /// <param name="services"></param>
        void Initialize(IModuleHost host, IServiceCollection servicesBuilder);

        /// <summary>
        /// Start plugin
        /// </summary>
        /// <param name="provider"></param>
        void Start();

        /// <summary>
        /// Stop plugin
        /// </summary>
        void Stop();
    }
}
